diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/qos-frame-exchange-manager.cc ns-3.45/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.44/src/wifi/model/qos-frame-exchange-manager.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/qos-frame-exchange-manager.cc	2025-06-01 20:34:45.622702100 -0700
@@ -44,7 +44,21 @@
                           "of QoS data frames sent by non-AP stations",
                           BooleanValue(false),
                           MakeBooleanAccessor(&QosFrameExchangeManager::m_setQosQueueSize),
-                          MakeBooleanChecker());
+                          MakeBooleanChecker())
+            .AddAttribute("ProtectSingleExchange",
+                          "Whether the Duration/ID field in frames establishing protection only "
+                          "covers the immediate frame exchange instead of rest of the TXOP limit "
+                          "when the latter is non-zero",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&QosFrameExchangeManager::m_protectSingleExchange),
+                          MakeBooleanChecker())
+            .AddAttribute(
+                "SingleExchangeProtectionSurplus",
+                "Additional time to protect beyond end of the immediate frame exchange in case of "
+                "non-zero TXOP limit when a single frame exchange is protected",
+                TimeValue(Time(0)),
+                MakeTimeAccessor(&QosFrameExchangeManager::m_singleExchangeProtectionSurplus),
+                MakeTimeChecker());
     return tid;
 }
 
@@ -101,6 +115,7 @@
                             &QosFrameExchangeManager::NotifyChannelReleased,
                             this,
                             m_edca);
+        ResetTxNav();
         return true;
     }
 
@@ -470,15 +485,18 @@
 {
     NS_LOG_FUNCTION(this << header << size << &txParams << fragmentedPacket);
 
+    const auto singleDurationId =
+        FrameExchangeManager::GetFrameDurationId(header, size, txParams, fragmentedPacket);
+
     // TODO This will be removed once no Txop is installed on a QoS station
     if (!m_edca)
     {
-        return FrameExchangeManager::GetFrameDurationId(header, size, txParams, fragmentedPacket);
+        return singleDurationId;
     }
 
     if (m_edca->GetTxopLimit(m_linkId).IsZero())
     {
-        return FrameExchangeManager::GetFrameDurationId(header, size, txParams, fragmentedPacket);
+        return singleDurationId;
     }
 
     NS_ASSERT(txParams.m_acknowledgment &&
@@ -488,10 +506,17 @@
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(
-        m_edca->GetRemainingTxop(m_linkId) -
-            WifiPhy::CalculateTxDuration(size, txParams.m_txVector, m_phy->GetPhyBand()),
-        *txParams.m_acknowledgment->acknowledgmentTime);
+    auto duration =
+        std::max(m_edca->GetRemainingTxop(m_linkId) -
+                     WifiPhy::CalculateTxDuration(size, txParams.m_txVector, m_phy->GetPhyBand()),
+                 *txParams.m_acknowledgment->acknowledgmentTime);
+
+    if (m_protectSingleExchange)
+    {
+        duration = std::min(duration, singleDurationId + m_singleExchangeProtectionSurplus);
+    }
+
+    return duration;
 }
 
 Time
@@ -501,25 +526,35 @@
 {
     NS_LOG_FUNCTION(this << rtsTxVector << txDuration << response);
 
+    const auto singleDurationId =
+        FrameExchangeManager::GetRtsDurationId(rtsTxVector, txDuration, response);
+
     // TODO This will be removed once no Txop is installed on a QoS station
     if (!m_edca)
     {
-        return FrameExchangeManager::GetRtsDurationId(rtsTxVector, txDuration, response);
+        return singleDurationId;
     }
 
     if (m_edca->GetTxopLimit(m_linkId).IsZero())
     {
-        return FrameExchangeManager::GetRtsDurationId(rtsTxVector, txDuration, response);
+        return singleDurationId;
     }
 
     // under multiple protection settings, if the TXOP limit is not null, Duration/ID
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(
-        m_edca->GetRemainingTxop(m_linkId) -
-            WifiPhy::CalculateTxDuration(GetRtsSize(), rtsTxVector, m_phy->GetPhyBand()),
-        Seconds(0));
+    auto duration =
+        std::max(m_edca->GetRemainingTxop(m_linkId) -
+                     WifiPhy::CalculateTxDuration(GetRtsSize(), rtsTxVector, m_phy->GetPhyBand()),
+                 Seconds(0));
+
+    if (m_protectSingleExchange)
+    {
+        duration = std::min(duration, singleDurationId + m_singleExchangeProtectionSurplus);
+    }
+
+    return duration;
 }
 
 Time
@@ -529,25 +564,35 @@
 {
     NS_LOG_FUNCTION(this << ctsTxVector << txDuration << response);
 
+    const auto singleDurationId =
+        FrameExchangeManager::GetCtsToSelfDurationId(ctsTxVector, txDuration, response);
+
     // TODO This will be removed once no Txop is installed on a QoS station
     if (!m_edca)
     {
-        return FrameExchangeManager::GetCtsToSelfDurationId(ctsTxVector, txDuration, response);
+        return singleDurationId;
     }
 
     if (m_edca->GetTxopLimit(m_linkId).IsZero())
     {
-        return FrameExchangeManager::GetCtsToSelfDurationId(ctsTxVector, txDuration, response);
+        return singleDurationId;
     }
 
     // under multiple protection settings, if the TXOP limit is not null, Duration/ID
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(
-        m_edca->GetRemainingTxop(m_linkId) -
-            WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()),
-        Seconds(0));
+    auto duration =
+        std::max(m_edca->GetRemainingTxop(m_linkId) -
+                     WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()),
+                 Seconds(0));
+
+    if (m_protectSingleExchange)
+    {
+        duration = std::min(duration, singleDurationId + m_singleExchangeProtectionSurplus);
+    }
+
+    return duration;
 }
 
 void
@@ -674,7 +719,17 @@
     m_initialFrame = false;
     m_sentFrameTo.clear();
     // reset TXNAV because transmission failed
-    m_txNav = Simulator::Now();
+    ResetTxNav();
+}
+
+void
+QosFrameExchangeManager::ReceivedMacHdr(const WifiMacHeader& macHdr,
+                                        const WifiTxVector& txVector,
+                                        Time psduDuration)
+{
+    NS_LOG_FUNCTION(this << macHdr << txVector << psduDuration.As(Time::MS));
+    FrameExchangeManager::ReceivedMacHdr(macHdr, txVector, psduDuration);
+    SetTxopHolder(macHdr, txVector);
 }
 
 void
@@ -713,15 +768,15 @@
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
 
-    SetTxopHolder(psdu, txVector);
+    SetTxopHolder(psdu->GetHeader(0), txVector);
     FrameExchangeManager::PostProcessFrame(psdu, txVector);
 }
 
 void
-QosFrameExchangeManager::SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+QosFrameExchangeManager::SetTxopHolder(const WifiMacHeader& hdr, const WifiTxVector& txVector)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector);
-    if (auto txopHolder = FindTxopHolder(psdu->GetHeader(0), txVector))
+    NS_LOG_FUNCTION(this << hdr << txVector);
+    if (auto txopHolder = FindTxopHolder(hdr, txVector))
     {
         m_txopHolder = *txopHolder;
     }
@@ -765,17 +820,19 @@
 }
 
 void
-QosFrameExchangeManager::UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+QosFrameExchangeManager::UpdateNav(const WifiMacHeader& hdr,
+                                   const WifiTxVector& txVector,
+                                   const Time& surplus)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector);
-    if (psdu->GetHeader(0).IsCfEnd())
+    NS_LOG_FUNCTION(this << hdr << txVector << surplus.As(Time::US));
+    if (hdr.IsCfEnd())
     {
         NS_LOG_DEBUG("Received CF-End, resetting NAV");
         NavResetTimeout();
         return;
     }
 
-    FrameExchangeManager::UpdateNav(psdu, txVector);
+    FrameExchangeManager::UpdateNav(hdr, txVector, surplus);
 }
 
 void
@@ -816,7 +873,7 @@
                                                  &QosFrameExchangeManager::SendCtsAfterRts,
                                                  this,
                                                  hdr,
-                                                 txVector.GetMode(),
+                                                 txVector,
                                                  rxSnr);
         }
         else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/qos-frame-exchange-manager.h ns-3.45/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.44/src/wifi/model/qos-frame-exchange-manager.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/qos-frame-exchange-manager.h	2025-06-01 20:34:45.622702100 -0700
@@ -108,7 +108,9 @@
     void PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void NavResetTimeout() override;
-    void UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+    void UpdateNav(const WifiMacHeader& hdr,
+                   const WifiTxVector& txVector,
+                   const Time& surplus = Time{0}) override;
     Time GetFrameDurationId(const WifiMacHeader& header,
                             uint32_t size,
                             const WifiTxParameters& txParams,
@@ -122,6 +124,9 @@
     void TransmissionSucceeded() override;
     void TransmissionFailed(bool forceCurrentCw = false) override;
     void ForwardMpduDown(Ptr<WifiMpdu> mpdu, WifiTxVector& txVector) override;
+    void ReceivedMacHdr(const WifiMacHeader& macHdr,
+                        const WifiTxVector& txVector,
+                        Time psduDuration) override;
 
     /**
      * Request the FrameExchangeManager to start a frame exchange sequence.
@@ -186,15 +191,21 @@
     std::optional<Mac48Address> m_txopHolder; //!< MAC address of the TXOP holder
     bool m_setQosQueueSize;                   /**< whether to set the Queue Size subfield of the
                                                    QoS Control field of QoS data frames */
+    bool m_protectSingleExchange; /**< true if the Duration/ID field in frames establishing
+                                     protection only covers the immediate frame exchange instead of
+                                     rest of the TXOP limit when the latter is non-zero */
+    Time m_singleExchangeProtectionSurplus; /**< additional time to protect beyond end of the
+                                               immediate frame exchange in case of non-zero TXOP
+                                               limit when a single frame exchange is protected */
 
   private:
     /**
      * Set the TXOP holder, if needed, based on the received frame
      *
-     * @param psdu the received PSDU
+     * @param hdr the MAC header of the received PSDU
      * @param txVector TX vector of the received PSDU
      */
-    void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
+    void SetTxopHolder(const WifiMacHeader& hdr, const WifiTxVector& txVector);
 
     /**
      * Cancel the PIFS recovery event and have the EDCAF attempting PIFS recovery
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.45/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2025-06-01 20:34:45.623702300 -0700
@@ -79,6 +79,16 @@
             .maxStreams = 8,
         },
     },
+    {
+        WIFI_MOD_CLASS_EHT,
+        {
+            .groupType = WIFI_MINSTREL_GROUP_EHT,
+            .maxMcs = 13,
+            .maxWidth = MHz_u{320},
+            .guardIntervals = {NanoSeconds(3200), NanoSeconds(1600), NanoSeconds(800)},
+            .maxStreams = 8,
+        },
+    },
 };
 
 /// MinstrelHtWifiRemoteStation structure
@@ -307,10 +317,15 @@
         m_numGroups += GetNumGroups(WIFI_MOD_CLASS_HE);
         m_numRates = minstrelHtStandardInfos.at(WIFI_MOD_CLASS_HE).maxMcs + 1;
     }
+    if (GetEhtSupported())
+    {
+        m_numGroups += GetNumGroups(WIFI_MOD_CLASS_EHT);
+        m_numRates = minstrelHtStandardInfos.at(WIFI_MOD_CLASS_EHT).maxMcs + 1;
+    }
 
     /**
      *  Initialize the groups array.
-     *  The HT groups come first, then the VHT ones, and finally the HE ones.
+     *  The HT groups come first, then the VHT ones, then the HE ones, and finally the EHT ones.
      *  Minstrel maintains different types of indexes:
      *  - A global continuous index, which identifies all rates within all groups, in [0,
      * m_numGroups * m_numRates]
@@ -340,6 +355,12 @@
         // Initialize all HE groups
         InitializeGroups(WIFI_MOD_CLASS_HE);
     }
+
+    if (GetEhtSupported())
+    {
+        // Initialize all EHT groups
+        InitializeGroups(WIFI_MOD_CLASS_EHT);
+    }
 }
 
 bool
@@ -1321,8 +1342,7 @@
                     /// set the rate that we're currently sampling
                     station->m_sampleRate = sampleIdx;
 
-                    NS_LOG_DEBUG("FindRate "
-                                 << "sampleRate=" << sampleIdx);
+                    NS_LOG_DEBUG("FindRate sampleRate=" << sampleIdx);
                     station->m_sampleTries--;
                     return sampleIdx;
                 }
@@ -1337,8 +1357,7 @@
                         /// set the rate that we're currently sampling
                         station->m_sampleRate = sampleIdx;
 
-                        NS_LOG_DEBUG("FindRate "
-                                     << "sampleRate=" << sampleIdx);
+                        NS_LOG_DEBUG("FindRate sampleRate=" << sampleIdx);
                         station->m_sampleTries--;
                         return sampleIdx;
                     }
@@ -1353,8 +1372,7 @@
 
     /// Continue using the best rate.
 
-    NS_LOG_DEBUG("FindRate "
-                 << "maxTpRrate=" << station->m_maxTpRate);
+    NS_LOG_DEBUG("FindRate maxTpRrate=" << station->m_maxTpRate);
     return station->m_maxTpRate;
 }
 
@@ -1673,6 +1691,12 @@
         {
             station->m_groupsTable[groupId].m_supported = false;
 
+            if ((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_EHT) &&
+                !GetEhtSupported(station))
+            {
+                // It is a EHT group but the receiver does not support EHT: skip
+                continue;
+            }
             if ((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_HE) &&
                 !GetHeSupported(station))
             {
@@ -1685,10 +1709,18 @@
                 // It is a VHT group but the receiver does not support VHT: skip
                 continue;
             }
-            if ((m_minstrelGroups[groupId].type != WIFI_MINSTREL_GROUP_HE) &&
+            if ((m_minstrelGroups[groupId].type != WIFI_MINSTREL_GROUP_EHT) &&
+                GetEhtSupported(station) && m_useLatestAmendmentOnly)
+            {
+                // It is not a EHT group and the receiver supports EHT: skip since
+                // UseLatestAmendmentOnly attribute is enabled
+                continue;
+            }
+            if (!GetEhtSupported(station) &&
+                (m_minstrelGroups[groupId].type != WIFI_MINSTREL_GROUP_HE) &&
                 GetHeSupported(station) && m_useLatestAmendmentOnly)
             {
-                // It is not a HE group and the receiver supports HE: skip since
+                // It is not a HE group and the receiver supports HE (but not EHT): skip since
                 // UseLatestAmendmentOnly attribute is enabled
                 continue;
             }
@@ -1814,9 +1846,7 @@
     uint32_t cwMax = 1023;
     Time cwTime;
     Time txTime;
-    Time dataTxTime;
     const auto slotTime = GetPhy()->GetSlot();
-    const auto ackTime = GetPhy()->GetSifs() + GetPhy()->GetBlockAckTxTime();
 
     if (station->m_groupsTable[groupId].m_ratesTable[rateId].ewmaProb < 1)
     {
@@ -1827,16 +1857,15 @@
         station->m_groupsTable[groupId].m_ratesTable[rateId].retryCount = 2;
         station->m_groupsTable[groupId].m_ratesTable[rateId].retryUpdated = true;
 
-        dataTxTime =
-            GetFirstMpduTxTime(
-                groupId,
-                GetMcsSupported(station,
-                                station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex)) +
-            GetMpduTxTime(
-                groupId,
-                GetMcsSupported(station,
-                                station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex)) *
-                (station->m_avgAmpduLen - 1);
+        auto mode =
+            GetMcsSupported(station, station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex);
+        WifiTxVector txVector;
+        txVector.SetMode(mode);
+        txVector.SetPreambleType(GetPreambleForTransmission(mode.GetModulationClass()));
+
+        const auto dataTxTime = GetFirstMpduTxTime(groupId, mode) +
+                                GetMpduTxTime(groupId, mode) * (station->m_avgAmpduLen - 1);
+        const auto ackTime = GetPhy()->GetSifs() + GetEstimatedAckTxTime(txVector);
 
         /* Contention time for first 2 tries */
         cwTime = (cw / 2) * slotTime;
@@ -2099,6 +2128,19 @@
 }
 
 std::size_t
+MinstrelHtWifiManager::GetEhtGroupId(uint8_t streams, Time guardInterval, MHz_u chWidth)
+{
+    NS_LOG_FUNCTION(this << streams << guardInterval << chWidth);
+    // This check is needed since HT is not supported in 6 GHz band
+    std::size_t allHtGroups = (GetHtSupported()) ? GetNumGroups(WIFI_MOD_CLASS_HT) : 0;
+    // This check is needed since VHT is not supported in 2.4 and 6 GHz bands
+    std::size_t allVhtGroups = (GetVhtSupported()) ? GetNumGroups(WIFI_MOD_CLASS_VHT) : 0;
+    const auto allHeGroups = GetNumGroups(WIFI_MOD_CLASS_HE);
+    const auto ehtGroupId = GetIdInGroup(WIFI_MOD_CLASS_EHT, streams, guardInterval, chWidth);
+    return allHtGroups + allVhtGroups + allHeGroups + ehtGroupId;
+}
+
+std::size_t
 MinstrelHtWifiManager::GetGroupIdForType(McsGroupType type,
                                          uint8_t streams,
                                          Time guardInterval,
@@ -2112,6 +2154,8 @@
         return GetVhtGroupId(streams, guardInterval, chWidth);
     case WIFI_MINSTREL_GROUP_HE:
         return GetHeGroupId(streams, guardInterval, chWidth);
+    case WIFI_MINSTREL_GROUP_EHT:
+        return GetEhtGroupId(streams, guardInterval, chWidth);
     default:
         NS_ABORT_MSG("Unknown group type: " << type);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h ns-3.45/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h
--- ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h	2025-06-01 20:34:45.623702300 -0700
@@ -37,6 +37,7 @@
     WIFI_MINSTREL_GROUP_HT,
     WIFI_MINSTREL_GROUP_VHT,
     WIFI_MINSTREL_GROUP_HE,
+    WIFI_MINSTREL_GROUP_EHT,
     WIFI_MINSTREL_GROUP_COUNT
 };
 
@@ -58,6 +59,8 @@
         return (os << "VHT");
     case WIFI_MINSTREL_GROUP_HE:
         return (os << "HE");
+    case WIFI_MINSTREL_GROUP_EHT:
+        return (os << "EHT");
     default:
     case WIFI_MINSTREL_GROUP_INVALID:
         return (os << "INVALID");
@@ -630,6 +633,17 @@
     std::size_t GetHeGroupId(uint8_t streams, Time guardInterval, MHz_u chWidth);
 
     /**
+     * Returns the groupId of an EHT MCS with the given number of streams, GI and channel width
+     * used.
+     *
+     * @param streams the number of streams
+     * @param guardInterval guard interval duration
+     * @param chWidth the channel width
+     * @returns the EHT group ID
+     */
+    std::size_t GetEhtGroupId(uint8_t streams, Time guardInterval, MHz_u chWidth);
+
+    /**
      * Returns the group ID of an MCS of a given group type with the given number of streams, GI and
      * channel width used.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.45/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.44/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2025-06-01 20:34:45.623702300 -0700
@@ -1038,7 +1038,7 @@
         {
             NS_LOG_DEBUG("  Checking " << retries << " retries");
             totalTxTimeWithGivenRetries =
-                CalculateTimeUnicastPacket(station->m_minstrelTable[i].perfectTxTime, 0, retries);
+                CalculateTimeUnicastPacket(GetSupported(station, i), 0, retries);
             NS_LOG_DEBUG("   totalTxTimeWithGivenRetries = " << totalTxTimeWithGivenRetries);
             if (totalTxTimeWithGivenRetries > MilliSeconds(6))
             {
@@ -1053,22 +1053,28 @@
 }
 
 Time
-MinstrelWifiManager::CalculateTimeUnicastPacket(Time dataTransmissionTime,
+MinstrelWifiManager::CalculateTimeUnicastPacket(WifiMode mode,
                                                 uint32_t shortRetries,
                                                 uint32_t longRetries)
 {
-    NS_LOG_FUNCTION(this << dataTransmissionTime << shortRetries << longRetries);
+    NS_LOG_FUNCTION(this << mode << shortRetries << longRetries);
     // See rc80211_minstrel.c
 
     // First transmission (Data + Ack timeout)
-    Time tt = dataTransmissionTime + GetPhy()->GetSifs() + GetPhy()->GetAckTxTime();
+    WifiTxVector txVector;
+    txVector.SetMode(mode);
+    txVector.SetPreambleType(
+        GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()));
+    const auto oneTxTime =
+        GetCalcTxTime(mode) + GetPhy()->GetSifs() + GetEstimatedAckTxTime(txVector);
+    auto tt = oneTxTime;
 
     uint32_t cwMax = 1023;
     uint32_t cw = 31;
     for (uint32_t retry = 0; retry < longRetries; retry++)
     {
         // Add one re-transmission (Data + Ack timeout)
-        tt += dataTransmissionTime + GetPhy()->GetSifs() + GetPhy()->GetAckTxTime();
+        tt += oneTxTime;
 
         // Add average back off (half the current contention window)
         tt += (cw / 2.0) * GetPhy()->GetSlot();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/rate-control/minstrel-wifi-manager.h ns-3.45/src/wifi/model/rate-control/minstrel-wifi-manager.h
--- ns-3.44/src/wifi/model/rate-control/minstrel-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/rate-control/minstrel-wifi-manager.h	2025-06-01 20:34:45.623702300 -0700
@@ -314,14 +314,12 @@
      *  - Data transmission
      *  - backoffs according to CW
      *
-     * @param dataTransmissionTime the data transmission time
+     * @param mode the WiFi mode used to transmit the data frame
      * @param shortRetries short retries
      * @param longRetries long retries
      * @returns the unicast packet time
      */
-    Time CalculateTimeUnicastPacket(Time dataTransmissionTime,
-                                    uint32_t shortRetries,
-                                    uint32_t longRetries);
+    Time CalculateTimeUnicastPacket(WifiMode mode, uint32_t shortRetries, uint32_t longRetries);
 
     /**
      * Print Sample Table.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc ns-3.45/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc
--- ns-3.44/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc	2025-06-01 20:34:45.624702200 -0700
@@ -226,10 +226,10 @@
         // Thompson sampling
         frameSuccessRate = SampleBetaVariable(1.0 + station->m_mcsStats.at(i).success,
                                               1.0 + station->m_mcsStats.at(i).fails);
-        NS_LOG_DEBUG("Draw"
-                     << " success=" << station->m_mcsStats.at(i).success
-                     << " fails=" << station->m_mcsStats.at(i).fails
-                     << " frameSuccessRate=" << frameSuccessRate << " mode=" << mode);
+        NS_LOG_DEBUG("Draw success=" << station->m_mcsStats.at(i).success
+                                     << " fails=" << station->m_mcsStats.at(i).fails
+                                     << " frameSuccessRate=" << frameSuccessRate
+                                     << " mode=" << mode);
         if (frameSuccessRate * rate > maxThroughput)
         {
             maxThroughput = frameSuccessRate * rate;
@@ -320,9 +320,8 @@
 
     station->m_lastMode = station->m_nextMode;
 
-    NS_LOG_DEBUG("Using"
-                 << " mode=" << mode << " channelWidth=" << channelWidth << " nss=" << +nss
-                 << " guardInterval=" << guardInterval);
+    NS_LOG_DEBUG("Using mode=" << mode << " channelWidth=" << channelWidth << " nss=" << +nss
+                               << " guardInterval=" << guardInterval);
 
     const auto rate = mode.GetDataRate(channelWidth, guardInterval, nss);
     if (m_currentRate != rate)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/reduced-neighbor-report.cc ns-3.45/src/wifi/model/reduced-neighbor-report.cc
--- ns-3.44/src/wifi/model/reduced-neighbor-report.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/reduced-neighbor-report.cc	2025-06-01 20:34:45.624702200 -0700
@@ -145,6 +145,10 @@
         {
             operatingClass = 134;
         }
+        else if (channel.GetWidth() == MHz_u{320})
+        {
+            operatingClass = 137;
+        }
         break;
     case WIFI_PHY_BAND_UNSPECIFIED:
     default:
@@ -154,7 +158,7 @@
 
     NS_ABORT_MSG_IF(operatingClass == 0,
                     "Operating class not found for channel number "
-                        << channelNumber << " width " << channel.GetWidth() << " MHz "
+                        << +channelNumber << " width " << channel.GetWidth() << " MHz "
                         << "band " << channel.GetPhyBand());
 
     // find the primary channel number
@@ -240,6 +244,10 @@
         band = WIFI_PHY_BAND_6GHZ;
         width = MHz_u{160};
         break;
+    case 137:
+        band = WIFI_PHY_BAND_6GHZ;
+        width = MHz_u{320};
+        break;
     default:
         break;
     }
@@ -726,4 +734,18 @@
     return count;
 }
 
+void
+ReducedNeighborReport::Print(std::ostream& os) const
+{
+    os << "Reduced Neighbor Report=[";
+    for (const auto& neighborApInfo : m_nbrApInfoFields)
+    {
+        os << "{Operating Class: " << +neighborApInfo.operatingClass
+           << ", Channel Number: " << +neighborApInfo.channelNumber
+           << ", TBTT Information Count: " << +neighborApInfo.tbttInfoHdr.tbttInfoCount
+           << ", TBTT Information Length: " << +neighborApInfo.tbttInfoHdr.tbttInfoLength << "}, ";
+    }
+    os << "]";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/reduced-neighbor-report.h ns-3.45/src/wifi/model/reduced-neighbor-report.h
--- ns-3.44/src/wifi/model/reduced-neighbor-report.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/reduced-neighbor-report.h	2025-06-01 20:34:45.624702200 -0700
@@ -24,7 +24,7 @@
  * @brief The Reduced Neighbor Report element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the Reduced Neighbor Report element.
+ * This class knows how to serialize and deserialize the Reduced Neighbor Report element.
  */
 class ReducedNeighborReport : public WifiInformationElement
 {
@@ -92,6 +92,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Get the number of Neighbor AP Information fields
